function main(DS)
%DS = 'mgh008';
tic
ploting = 0;
reference = 0;

ST =  0;
Folder = '';

addpath(genpath(pwd));
Datnum = DS;

AL = ['00:' int2str(ST) ':00'];
OM = ['00:' int2str(ST+10) ':00'];

    %############################################%
    %       --- Load Data Manually ---           %
    %############################################%
    %Load data
	Data = dat2octave(Datnum);
    idxECG = [];
    idxBP  = [];
    idxSV  = [];
    for i = 1: length(Data(1,:))
		switch Data(1,i)
		case 1
			idxECG = [idxECG i];
		case 2
			idxBP  = [idxBP i];
		case 3
			idxSV  = [idxSV i];
		end;	
	end;
	%Sample frequency
	fSamp = Data(1,1)	

	ECGDat(:,1:length(idxECG)) = Data(2:max(Data(:,1))+1,idxECG);
    BPDat(:,1:length(idxBP)) = Data(2:max(Data(:,1))+1,idxBP);
    SVDat(:,1:length(idxSV)) = Data(2:max(Data(:,1))+1,idxSV);

	EcgBpAnnos = ann2octave(Datnum,length(idxECG),length(idxBP));
    
    ECGwfdbAnns = nan(3,1200);
    BPwfdbAnns  = nan(3,1200);
%for i = 1:length(idxECG) 
%	out = newQRS_test(ECGDat(:,i),fSamp);
%	ECGwfdbAnns(i,1:length(out)) = out;  %[ECGwfdbstruct.sampleNumber]-ST*fSamp*60;
%end;	
    ECGwfdbAnns = EcgBpAnnos(:,1:length(idxECG))';
    BPwfdbAnns  = EcgBpAnnos(:,length(idxECG)+1:end)';


;
    

    %Data-Standardisation

	Data(:,1) = Data(:,1)-ST*fSamp*60;

	for i = 1:length(idxECG)
    	ECGDat(:,i) = (ECGDat(:,i)-mean(ECGDat(:,i)))./std(ECGDat(:,i));
	end;

    if ~isempty(BPDat)
		for i = 1:length(idxBP)
        	BPDat(:,i) = (BPDat(:,i)-mean(BPDat(:,i)))./std(BPDat(:,i));
    	end;
	end;

    if ~isempty(SVDat)
		for i = 1:length(idxSV)
        	windowSize = round(fSamp/3);
        	SVDat(:,i) = filter(ones(1,windowSize)/windowSize,1,SVDat(:,i));
        	SVDat(:,i) = filter(ones(1,windowSize)/windowSize,1,SVDat(:,i));
        	SVDat(2:end,i) = diff(SVDat(:,i));
        	SVDat(:,i) = [SVDat(2,i); SVDat(2:end,i)];
        	SVDat(:,i) = (SVDat(:,i)-mean(SVDat(:,i)))./std(SVDat(:,i));
    	end;
	end;


    %Interval parameters
    interval = 1 ;      %Segment Size (s)
    overlap  =  3;      %Segment overlapping (s)
    tolerance = 0.1;    %time tolerance of double-found annotations (s)

    %Displacement parameters
    NEcgAndBpsGood = [0 0 0 0];
    EcgToBspDiff   = [0 0 0 0];
    NEcgAndSVGood  = [0 0 0 0];
    EcgToSVDiff    = [0 0 0 0];
    
    MaxVar = 0.04;
    
    % frequency of the fundamental harmonic
    for i=[idxECG idxBP];
        f1arr(i-1) = basicFFT(Data(2:max(Data(:,1)),i),fSamp);
    end;
    if min(f1arr)/max(f1arr)<0.5
        f1 =nan;
    else
        f1 = mean(f1arr(f1arr>0));
    end;
         
    
    
    %Initialize Anno Arrays
    ECGAnno   = struct('annos',0,'length',0,'quali',0,'var',0,'max',0,'min',0);
    BPAnno    = struct('annos',0,'length',0,'quali',0,'DiffToECG',0);
    SVAnno    = struct('annos',0,'length',0,'quali',0,'DiffToECG',0);
    ECGBPAnno = struct('annos',0,'length',0,'quali',0,'var',0,'max',0,'min',0);
    
    Ins = struct('anno',0);
    Anno = [];

    k = 0;
    
%############################################%
%       --- Array-filling-Loop ---           %
%############################################%
    for i = 1:interval*fSamp:length(ECGDat); 
        k = k+1; % Counter Variable
        start = i;
        stopp = (i+interval*fSamp+overlap*fSamp);
        if (stopp > length(ECGDat))
            stopp = length(ECGDat);
        end

        %############################################%
        %          --- ECG-Analysis ---              %
        %############################################%
        for j = 1:length(idxECG)
            %Search for ECG-Peaks in actual Segment
            ECGpeakpos = ECGwfdbAnns(j,ECGwfdbAnns(j,:)>start & ECGwfdbAnns(j,:)<stopp);

            %Write in ECG-Annotations array ECGAnno
            if  isempty(ECGpeakpos)
                ECGAnno(j,k).annos  = 0;
                ECGAnno(j,k).length = 0;
                ECGAnno(j,k).varRR = MaxVar*2;
            else
                ECGAnno(j,k).annos = ECGpeakpos;
                ECGAnno(j,k).length = length(ECGpeakpos);
                if length(ECGpeakpos)>2
                    ECGAnno(j,k).varRR = var(diff(ECGpeakpos)/max(diff(ECGpeakpos)));
                else
                    ECGAnno(j,k).varRR = MaxVar*2;
                end;
            end;

            %ECG-Signal Quality initialization
            ECGAnno(j,k).quali = 2;
            ECGAnno(j,k).sigvar = var(ECGDat(start:stopp,j));
        end;
        %############################################%
        %          --- BP-Analysis ---               %
        %############################################%
        for j = 1:length(idxBP)
            if ~isempty(BPDat)
                %Search for ECG-Peaks in actual Segment
                BPpeakpos = BPwfdbAnns(j,BPwfdbAnns(j,:)>start & BPwfdbAnns(j,:)<stopp);

                %Write in BPS-Annotations array BPAnno
                if isempty(BPpeakpos)
                    BPAnno(j,k).annos  = 0;
                    BPAnno(j,k).length = 0;  
                    BPAnno(j,k).varRR = MaxVar*2;      
                else
                    BPAnno(j,k).annos  = BPpeakpos;
                    BPAnno(j,k).length = length(BPpeakpos);
                    if length(BPpeakpos)>2
                        BPAnno(j,k).varRR = var(diff(BPpeakpos)/max(diff(BPpeakpos)));
                    else
                        BPAnno(j,k).varRR = MaxVar*2; 
                    end;        
                end;

                %BPS-Signal Quality initialization
                BPAnno(j,k).quali = 2;
                BPAnno(j,k).sigvar =var(BPDat(start:stopp,j));
            else
                BPAnno(j,k).DiffToECG = [];
                BPAnno(j,k).quali = 0;
                BPAnno(j,k).annos = [];
                BPAnno(j,k).length = 0;
                BPAnno(j,k).varRR = MaxVar*2; 
            end;
        end;

        %############################################%
        %          --- SV-Analysis ---               %
        %############################################%

        if ~isempty(SVDat)
            for j = 1:length(idxSV)
                %SV Peak-Detection
                SVpeaks  = findpeak(SVDat(start:stopp-1,j),round(fSamp/2.5),0.2);
                SVpeaks = SVpeaks'+start-1;%Index correction for interval

                %Write in SV-Annotations array SVAnno
                if isempty(SVpeaks)
                    SVAnno(j,k).annos  = 0;
                    SVAnno(j,k).length = 0;  
                    SVAnno(j,k).varRR = MaxVar*2; 
                else
                    SVAnno(j,k).annos  = SVpeaks;
                    SVAnno(j,k).length = length(SVpeaks);
                    if length(SVpeaks)>2
                        SVAnno(j,k).varRR = var(diff(SVpeaks)/max(diff(SVpeaks)));
                    else
                        SVAnno(j,k).varRR = MaxVar*2; 
                    end;
                end;

                %SV-Signal Quality initialization
                SVAnno(j,k).quali = 2;
                SVAnno(j,k).sigvar =var(SVDat(start:stopp,j));
            end;
        else
            SVAnno(1,k).DiffToECG = [];
            SVAnno(1,k).quali = 0;
            SVAnno(1,k).annos = [];
            SVAnno(1,k).length = 0;
            SVAnno(1,k).varRR = MaxVar*2; 
        end;
        
    end; % big for-loop for data analysis and peak finding

%############################################%
%   --- Quality and Displacement Loop ---    %
%############################################%
    for k = 1:1:max(Data(:,1))/fSamp/interval;

        % Interval start and stop
        start = (k-1)*interval*fSamp;
        stopp = (k*interval+overlap)*fSamp;
        if (stopp > length(ECGDat))
            stopp = length(ECGDat);
        end

        % ECG-Quality
        dispidx = 0;
        for j = length(idxECG):-1:1
            ECGAnno(j,k).quali = GetQuali(ECGAnno(j,k), start, stopp, fSamp,f1);
            if ECGAnno(j,k).quali == 2 
                dispidx = j;
            end;
        end;
        if ~isempty(BPDat)
            for j = 1:length(idxBP)
                % BP-Quality 
                BPAnno(j,k).quali = GetQuali(BPAnno(j,k), start, stopp, fSamp,f1);

                % BP-Peak displacement
                if (dispidx > 0) && (BPAnno(j,k).quali == 2)
                    BPAnno(j,k).DiffToECG = 0;          
                    for m = 1:1:length(ECGAnno(dispidx,k).annos)
                        for l = length(BPAnno(j,k).annos):-1:1
                            if ECGAnno(dispidx,k).annos(m)<BPAnno(j,k).annos(l)
                                if BPAnno(j,k).annos(l)-ECGAnno(dispidx,k).annos(m)<fSamp/2
                                    NEcgAndBpsGood(j) = NEcgAndBpsGood(j) + 1;
                                    BPAnno(j,k).DiffToECG = BPAnno(j,k).DiffToECG + BPAnno(j,k).annos(l)-ECGAnno(dispidx,k).annos(m);
                                break
                                end;
                            end;
                        end;
                    end;
                    EcgToBspDiff(j) = EcgToBspDiff(j) + BPAnno(j,k).DiffToECG;
                end; 
            end;
        end;

        if ~isempty(SVDat)
            for j = 1:length(idxSV)
                % SV-Quality 
                SVAnno(j,k).quali = GetQuali(SVAnno(j,k), start, stopp, fSamp,f1);

                % SV-Peak displacement
                if (dispidx>0) && (SVAnno(j,k).quali == 2)
                    SVAnno(j,k).DiffToECG = 0;          
                    for m = 1:1:length(ECGAnno(dispidx,k).annos)
                            for l = length(SVAnno(j,k).annos):-1:1
                                if ECGAnno(dispidx,k).annos(m) < SVAnno(j,k).annos(l)
                                    if SVAnno(j,k).annos(l)-ECGAnno(dispidx,k).annos(m)<fSamp/2
                                        NEcgAndSVGood(j) = NEcgAndSVGood(j) + 1;
                                        SVAnno(j,k).DiffToECG = SVAnno(j,k).DiffToECG + SVAnno(j,k).annos(l)-ECGAnno(dispidx,k).annos(m);
                                    break
                                    end;
                                end;
                            end;
                    end;
                    EcgToSVDiff(j) = EcgToSVDiff(j) + SVAnno(j,k).DiffToECG;
                end;   
            end;
        else
            SVAnno(1,k).quali = 0;
            
        end;     

    end; %Quality Loop

    %Calculate final displacements to BP and SV
    EcgToBspDiff = round(EcgToBspDiff./NEcgAndBpsGood); 
    EcgToBspDiff(NEcgAndBpsGood<=15) = fSamp/5;

    EcgToSVDiff = round(EcgToSVDiff./NEcgAndSVGood);
    EcgToSVDiff(NEcgAndSVGood<=5) = fSamp/5;

    %############################################%
    %---Creation of ECG&BP-Anno struct in Loop---%
    %############################################%
    for k = 1:1:max(Data(:,1))/fSamp/interval;

        % Interval start and stop
        start = (k-1)*interval*fSamp;
        stopp = (k*interval+overlap)*fSamp;
        if (stopp > length(ECGDat))
            stopp = length(ECGDat);
        end
        % Make new Annotation struct for matching ECG and BP Annotations
        Annos = nan(length(idxECG)+length(idxBP),20);
        for j = 1: length(idxECG);
            if ECGAnno(j,k).sigvar>0.05 && ECGAnno(j,k).sigvar<5 %&& min(diff(ECGAnno(j,k).annos/fSamp))>0.1
                Annos(j,1:ECGAnno(j,k).length) = ECGAnno(j,k).annos;
            end;
        end;
        for j = 1: length(idxBP);
            if BPAnno(j,k).sigvar>0.05 && BPAnno(j,k).sigvar<5 %&& min(diff(BPAnno(j,k).annos/fSamp))>0.1
                Annos(j+length(idxECG),1:BPAnno(j,k).length) = BPAnno(j,k).annos-EcgToBspDiff(j);
            end;
        end;
        [ECGBPAnno(1,k).annos ECGBPAnno(2,k).annos ECGBPAnno(3,k).annos] = get_multis(Annos,tolerance*fSamp);

        for j = 1:3
            ECGBPAnno(j,k).length = length([ECGBPAnno(j,k).annos]);
            if ECGBPAnno(j,k).length>2
                ECGBPAnno(j,k).varRR = var(diff(ECGBPAnno(j,k).annos)/max(diff(ECGBPAnno(j,k).annos)));
            else
                ECGBPAnno(j,k).varRR = MaxVar*2;
            end;
            ECGBPAnno(j,k).sigvar = 1;
            ECGBPAnno(j,k).quali = GetQuali(ECGBPAnno(j,k), start, stopp, fSamp,f1);
        end;

    end;

    
    %############################################%
    %    --- Build final Annotation-Array ---    %
    %############################################%
    RunTwo = [];
    for k = 1:1:max(Data(:,1))/fSamp/interval;
        QualArr = [ECGBPAnno(:,k).quali ECGAnno(:,k).quali BPAnno(:,k).quali  SVAnno(:,k).quali];
        VarArr  = [ECGBPAnno(:,k).varRR   ECGAnno(:,k).varRR   BPAnno(:,k).varRR    SVAnno(:,k).varRR];

        if max(QualArr) == 2
            [bla,idx]=max(QualArr);
            if idx>3 && idx<4+length(idxECG)+length(idxBP)%for all single annotation arrays
                minivar = min(VarArr(QualArr(1:3+length(idxECG)+length(idxBP))==2)); %Don't include SV-array in selection
                [bla,idx] = min(abs(VarArr-minivar));
            end;
            idxarr(k)=idx;
            if idx <= 3
                Anno = AddAnno(Anno, ECGBPAnno(idx,k).annos, tolerance,fSamp);
            end;
            if (idx > 3 && idx <= 3+length(idxECG))
                    Anno = AddAnno(Anno, ECGAnno(idx-3,k).annos, tolerance,fSamp);
            end;
            if (idx > 3+length(idxECG) && idx <= 3+length(idxECG)+length(idxBP))
                    Anno = AddAnno(Anno, BPAnno(idx-3-length(idxECG),k).annos-EcgToBspDiff(idx-3-length(idxECG)), tolerance,fSamp);
            end;
            if idx > 3+length(idxECG)+length(idxBP)
                Anno = AddAnno(Anno, SVAnno(k).annos-EcgToSVDiff(idx-3-length(idxECG)), tolerance,fSamp);
            end;   
        else
            RunTwo = [RunTwo k];
        end;
        if k < 230 && k>227
            k=k;
        end;
    end; %first run for filling up the array Anno with the best Annotations

    if isempty(Anno)
        Anno=[0, length(ECGDat)];
    end;
    
    
    for k = RunTwo %interval variable
        
        for j = 1:interval+overlap
            if max(RunTwo == k-j)==0
                unten = j-1;
                break;
            end;
        end;
        
        for j = 1:interval+overlap
            if max(RunTwo == k+j)==0
                break;
            end;
        end;
        oben=j-1;
        if oben>=0
            
            QualArr = [ECGBPAnno(:,k).quali ECGAnno(:,k).quali BPAnno(:,k).quali  SVAnno(:,k).quali];
            VarArr  = [ECGBPAnno(:,k).varRR   ECGAnno(:,k).varRR   BPAnno(:,k).varRR    SVAnno(:,k).varRR];

            if max(QualArr == 1)
                [bla,idx] = max(QualArr);
                if idx>3
                    minivar = min(VarArr(QualArr==1));
                    [bla,idx] = min(abs(VarArr-minivar));
                end;

                if idx <= 3
                    ins = ECGBPAnno(idx,k).annos;
                end;
                if (idx > 3 && idx <= 3+length(idxECG))
                    ins = ECGAnno(idx-3,k).annos;
                end;
                if (idx > 3+length(idxECG) && idx <= 3+length(idxECG)+length(idxBP))
                    ins = BPAnno(idx-3-length(idxECG),k).annos-EcgToBspDiff(idx-3-length(idxECG));
                end;
                if idx > 3+length(idxECG)+length(idxBP)
                    ins = SVAnno(k).annos-EcgToSVDiff(idx-3-length(idxECG));
                end;
                
                for u = length(Anno)-1:-1:1
                    if Anno(u)<(k+oben)*interval*fSamp
                        break;
                    end;
                end;
                for o = 1:length(Anno)-1
                    if Anno(o)>(k+oben)*interval*fSamp
                        break;
                    end;
                end;        
                ins = ins((ins>Anno(u)+2*tolerance*fSamp & ins<Anno(o)-2*tolerance*fSamp) |...
                        ins>Anno(end)+tolerance*fSamp |...
                        ins<Anno(1)-tolerance*fSamp);

                if ~isempty(ins)
                    if u == 1
                        Anno = [ins Anno(j:end)];
                    else    
                        if ins(1)>Anno(end)
                            Anno = [Anno(1:end) ins];
                        else
                            Anno = [Anno(1:u) ins Anno(o:end)];   
                        end;
                    end;
                end;
            end;
        end;  
    end; % Loop Run two of Annotation filling 
if Anno(1) == 0
    Anno = Anno(2:end);
end;

if Anno(end) == length(ECGDat);
    Anno = Anno(1:end-1);
end;
if ~isempty(Anno)
    for i = 1:length(idxBP)
        if Anno(1)>fSamp*0.5 && BPAnno(i,1).quali == 2 && ...
           BPAnno(i,1).annos(1) - EcgToBspDiff(i) < round(0.35*fSamp) && ...
           BPAnno(i,1).annos(1) - EcgToBspDiff(i) > -round(0.038*fSamp)
           Anno = [BPAnno(i,1).annos(1)- EcgToBspDiff(i) Anno];
        end;
    end;

    for i = 1:length(idxECG)
        if Anno(end) < length(ECGDat)-fSamp*0.5 && ECGAnno(i,end).quali == 2 && ...
           ECGAnno(i,end).annos(end)> round(length(ECGDat)-0.35*fSamp) && ...
           ECGAnno(i,end).annos(end)< length(ECGDat)
            Anno = [Anno ECGAnno(i,end).annos(end)];
        end;
    end;
end;
octave2annfile(Anno, Datnum);
disp(["--- Record: " Datnum " done. Time: " num2str(toc) " ---"]);
