function Wert = GetQuali(Anno, start, stopp, fSamp, f1)
%   Wert = 2: Signal with good quality
%   Wert = 1: Signal with average quality (probably one Annotation missing)
%   Wert = 0: Signal with bad Quality (Way too much or less Annotations)
if isnan(f1)
    MaxDiff = 2.5;
    MinDiff = 0.3;
    MaxLength = 12;
    MinLength = 2;    
else
    MaxDiff = 2/f1;
    MinDiff = .5/f1;
    MaxLength = ceil((stopp-start)/fSamp*f1*1.4);
    MinLength = floor((stopp-start)/fSamp*f1/1.7);
    if MinLength == 0 
        MinLength = 1; 
    end;
end;
MaxVar = 0.030;
sigvarmin = 0.05;
sigvarmax = 5;
    Wert = 2;
% strict requirements: condition violation -> signal not useful    
if  (Anno.length >  MaxLength) ||...
    (Anno.length < MinLength)||...
    (Anno.varRR > MaxVar*3)||...
    (Anno.sigvar < sigvarmin*0.01)||...
    (Anno.sigvar > sigvarmax*100);
    Wert = 0;
else
    % non-strict requirements: condition violation -> signal useful under conditions
    if  (stopp-Anno.annos(end) > 1.5*mean(diff(Anno.annos)))||...
        (Anno.annos(1)-start > 1.5*mean(diff(Anno.annos)))||...
        (Anno.varRR > MaxVar)||...
        (max(diff(Anno.annos/fSamp)) > MaxDiff) ||...
        (min(diff(Anno.annos/fSamp)) < MinDiff)||...
        (Anno.sigvar < sigvarmin)||...
        (Anno.sigvar > sigvarmax);%||...
        %((Anno.max < MaxMean/2)||...
        %(Anno.max > MaxMean*2)) && Anno.var>Quali.MaxVar/4;
        Wert = 1;
    end;
end;